using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace CShare.NET2005
{
    public partial class MainForm : Form
    {
        //Interface definitions.
        //==============================================================================================================
        [DllImport("xpstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakBegin();

        [DllImport("xpstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakEnd(int nHandle);

        [DllImport("xpstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakExport(int nHandle);

        [DllImport("xpstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakSetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,  
                                                int nValue2,   
                                                string lpValue1,  
                                                string lpValue2);

        [DllImport("xpstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakGetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,
                                                int nValue2,
                                                string lpValue1,
                                                string lpValue2);


    //Definitions of oakSetOption's nIndex properties
    //======================================================================================================
    const int OAK_Set_Output = 2101;
    const int OAK_Set_Input = 2102;
    const int OAK_Set_DPI = 2103;
    const int OAK_Set_ColorDepth = 2104;
    const int OAK_Set_PDFInfo = 2105;
    const int OAK_Set_PDFEncrypt = 2106;
    const int OAK_Set_Compression = 2108;
    const int OAK_Set_Quality = 2109;
   
    //file type's definitions.
    //==============================================================================================================
    const int OAK_FILE_PDF = 100;
    const int OAK_FILE_TIF = 105;
    const int OAK_FILE_JPG = 106;
    const int OAK_FILE_BMP = 107;
    const int OAK_FILE_GIF = 108;
    const int OAK_FILE_PCX = 109;
    const int OAK_FILE_PNG = 110;
    const int OAK_FILE_EMF = 111;
    const int OAK_FILE_WMF = 112;

    //TIFF tag's definitions.
    //==============================================================================================================
    const int OAK_COMPRESSION_NONE = 1;
    const int OAK_COMPRESSION_RLE = 2;
    const int OAK_COMPRESSION_G3 = 3;
    const int OAK_COMPRESSION_G4 = 4;
    const int OAK_COMPRESSION_LZW = 5;
    const int OAK_COMPRESSION_JPEG = 6;
    const int OAK_COMPRESSION_PACKBITS = 7;


    //Color Depth
    //==============================================================================================================
    const int oak_color_1 = 1 ;   //2 colors
    const int oak_color_4 = 4 ;   //16 colors
    const int oak_color_8_g = 7 ; //256 grayscale colors
    const int oak_color_8 = 8  ;  //256 colors
    const int oak_color_24 = 24;  //true colors
   

    //Supported pdf information
    const string OAK_PDFInfo_TITLE = "title";
    const string OAK_PDFInfo_SUBJECT = "subject";
    const string OAK_PDFINfo_AUTHOR = "author";
    const string OAK_PDFINfo_KEYWORDS = "keywords";
    const string OAK_PDFInfo_APPLICATION = "creator";

    //Supported the length of pdf encrypt
    const int OAK_PDF_ENCRYPT_LEVEL_40 = 40;
    const int OAK_PDF_ENCRYPT_LEVEL_128 = 128;

    //Supported operation limited
    const int OAK_PDF_PERMISSION_NONE = 0;
    const int OAK_PDF_PERMISSION_PRINT = 1;
    const int OAK_PDF_PERMISSION_COPYING = 2;
    const int OAK_PDF_PERMISSION_MODIFY = 4;
    const int OAK_PDF_PERMISSION_ALL = 7;


  
            
        //==============================================================================================================

        public MainForm()
        {
            InitializeComponent();
        }




        void xpstopdf()
        {
	        int id;
	        string sOutFname;
            string sOwnerPw = "user";
            string sUserPw = "owner";
	        int xdpi=200;
	        int ydpi=200;

            id = oakBegin();
            if (id != 0)
            {

		        //=============================================================
		        //set output file
                sOutFname = "output.pdf";
		        oakSetOption(id, OAK_Set_Output, OAK_FILE_PDF, 0, sOutFname, null);

		        //set image DPI ,default xdpi=150,ydpi=150
		        oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set pdf info
		        oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "test title");
		        oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "test subject");
		        oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, "test author");
		        oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, "test keywords");
		        oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "test creator");

		        //set pdf security
                oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, null, sOwnerPw);
		        //oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

		        //set input file
		        oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
		        oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
		        oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);

        		
		        //strat convert
		        long lret = oakExport(id);

		        oakEnd(id);
	        }

        }


        void xpstotif_MP()
        {
	        int id;
	        int isMultiPage; 
	        int xdpi, ydpi;
	        int iCompression;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {

			        //=============================================================
			        //set output file
			        isMultiPage = 1;
			        sOutFname="MultiPage_g4.tif";
                    oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutFname, null);
        			
			        //set dpi
                    xdpi = 200;
                    ydpi = 200;
                    oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);
        			
			        //set Color Depth
                    oakSetOption(id, OAK_Set_ColorDepth, oak_color_1, 0, null, null);

			        //set COMPRESSION
			        iCompression = OAK_COMPRESSION_G4;
                    oakSetOption(id, OAK_Set_Compression, iCompression, 0, null, null);
        			
			        //set input file
                    oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                    oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                    oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        			
			        //strat convert
			        oakExport(id);

			        oakEnd(id);
		        }
        }

        void xpstotif_OP()
        {
	        int id;
	        int isMultiPage; 
	        int xdpi, ydpi;
	        int iCompression;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {

		        //=============================================================
		        //set output file
		        isMultiPage = 0;
                sOutFname = "lzw.tif";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutFname, null);
        		
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);
        		
		        //set COMPRESSION
		        iCompression = OAK_COMPRESSION_LZW;
                oakSetOption(id, OAK_Set_Compression, iCompression, 0, null, null);

		        //set Color Depth
                //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, null, null);
        		
		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }
        }

        void xpstojpg()
        {
	        int id;
	        int xdpi, ydpi;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {
		        //=============================================================
		        //set output file
                sOutFname = "output.jpg";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_JPG, 0, sOutFname, null);
        			
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set jpeg quality (1 - 100)
                oakSetOption(id, OAK_Set_Quality, 75, 0, null, null);

		        //set Color Depth
                //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, null, null);
        				
		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }

        void xpstobmp()
        {
	        int id;
	        int xdpi, ydpi;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {
		        //=============================================================
		        //set output file
                sOutFname = "output.bmp";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_BMP, 0, sOutFname, null);
        			
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set Color Depth
                oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, null, null);
        				
		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }

        void xpstogif()
        {
	        int id;
	        int xdpi, ydpi;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {
		        //=============================================================
		        //set output file
                sOutFname = "output.gif";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_GIF, 0, sOutFname, null);
        			
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);
        				
		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }


        void xpstopng()
        {
	        int id;
	        int xdpi, ydpi;
	        string sOutFname;

            id = oakBegin();
            if (id != 0)
            {
		        //=============================================================
		        //set output file
                sOutFname = "output.png";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_PNG, 0, sOutFname, null);
        			
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set Color Depth
                oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, null, null);				

		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }

        void xpstopcx()
        {
	        int id;
	        int xdpi, ydpi;
	        string sOutFname;

            id = oakBegin();
            if (id != 0){
		        //=============================================================
		        //set output file
                sOutFname = "output.pcx";
                oakSetOption(id, OAK_Set_Output, OAK_FILE_PCX, 0, sOutFname, null);
        			
		        //set dpi
                xdpi = 200;
                ydpi = 200;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set Color Depth
                //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, null, null);				

		        //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
                //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
		        //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }

        void xpstoemf()
        {
            int id;
            int xdpi, ydpi;
            string sOutFname;

            id = oakBegin();
	        if( id !=0){
		        //=============================================================
		        //set output file
		        sOutFname= "output.emf";
		        oakSetOption(id, OAK_Set_Output, OAK_FILE_EMF, 0, sOutFname, null);
        			
		        //set dpi
		        xdpi = 200;
                ydpi = 200;
		        oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, null, null);

		        //set Color Depth
		        //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, null, null);				

		        //set input file
		        oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", null);
		        //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", null);
		        //oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", null);
        		
		        //strat convert
		        oakExport(id);

		        oakEnd(id);
	        }

        }


        //==============================================================================================================
        private void btnDemo1_Click(object sender, EventArgs e)
        {
            xpstopdf();
            xpstotif_MP();
            xpstotif_OP();
            xpstojpg();

            xpstobmp();
            xpstogif();
            xpstopng();
            xpstopcx();
            xpstoemf();
        }


        private void MainForm_Load(object sender, EventArgs e)
        {

        }


    }
}