//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "direct.h"
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void TMainForm::xpstopdf()
{
	long id;
	char sOutFname[_MAX_PATH];
    char sOwnerPw[] = "user";
	char sUserPw[]  = "owner";
	int xdpi=200;
	int ydpi=200;

	if( id = oakBegin() ){

		//=============================================================
		//set output file
		strcpy(sOutFname, "output.pdf");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_PDF, 0, sOutFname, NULL);

		//set image DPI ,default xdpi=150,ydpi=150
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set pdf info
		oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "test title");
		oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "test subject");
		oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, "test author");
		oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, "test keywords");
		oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "test creator");

		//set pdf security
		oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, NULL, sOwnerPw);
		//oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);

		
		//strat convert
		long lret = oakExport(id);

		oakEnd(id);
	}

}


void TMainForm::xpstotif_MP()
{
	long id;
	long isMultiPage; 
	long xdpi, ydpi;
	long iCompression;
	char sOutFname[_MAX_PATH];

		if( id = oakBegin() ){

			//=============================================================
			//set output file
			isMultiPage = TRUE;
			strcpy(sOutFname, "MultiPage_g4.tif");
			oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutFname, NULL);
			
			//set dpi
			xdpi = 200, ydpi = 200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);
			
			//set Color Depth
			oakSetOption(id, OAK_Set_ColorDepth, oak_color_1, 0, NULL, NULL);

			//set COMPRESSION
			iCompression = OAK_COMPRESSION_G4;
			oakSetOption(id, OAK_Set_Compression, iCompression, 0, NULL, NULL);
			
			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
			
			//strat convert
			oakExport(id);

			oakEnd(id);
		}
}

void TMainForm::xpstotif_OP()
{
	long id;
	long isMultiPage; 
	long xdpi, ydpi;
	long iCompression;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){

		//=============================================================
		//set output file
		isMultiPage = FALSE;
		strcpy(sOutFname, "lzw.tif");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutFname, NULL);
		
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);
		
		//set COMPRESSION
		iCompression = OAK_COMPRESSION_LZW;
		oakSetOption(id, OAK_Set_Compression, iCompression, 0, NULL, NULL);

		//set Color Depth
		//oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, NULL, NULL);
		
		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}
}

void TMainForm::xpstojpg()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "outputa.jpg");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_JPG, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set jpeg quality (1 - 100)
		oakSetOption(id, OAK_Set_Quality, 75, 0, NULL, NULL);

		//set Color Depth
		//oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, NULL, NULL);
				
		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}

void TMainForm::xpstobmp()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "output.bmp");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_BMP, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set Color Depth
		oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, NULL, NULL);
				
		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}

void TMainForm::xpstogif()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "output.gif");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_GIF, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);
				
		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}


void TMainForm::xpstopng()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "output.png");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_PNG, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set Color Depth
		oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, NULL, NULL);				

		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}

void TMainForm::xpstopcx()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "output.pcx");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_PCX, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set Color Depth
		//oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, NULL, NULL);				

		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}

void TMainForm::xpstoemf()
{
	long id;
	long xdpi, ydpi;
	char sOutFname[_MAX_PATH];

	if( id = oakBegin() ){
		//=============================================================
		//set output file
		strcpy(sOutFname, "output.emf");
		oakSetOption(id, OAK_Set_Output, OAK_FILE_EMF, 0, sOutFname, NULL);
			
		//set dpi
		xdpi = 200, ydpi = 200;
		oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

		//set Color Depth
		//oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, NULL, NULL);				

		//set input file
		oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test1.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test2.xps", NULL);
		//oakSetOption(id, OAK_Set_Input, 0, 0, ".\\xps_files\\test3.xps", NULL);
		
		//strat convert
		oakExport(id);

		oakEnd(id);
	}

}

void __fastcall TMainForm::btnDemo1Click(TObject *Sender)
{
	if( Load() ){

               	xpstopdf();
		xpstotif_MP();
		xpstotif_OP();
		xpstojpg();

		xpstobmp();
                xpstogif();
		xpstopng();
		xpstopcx();
		xpstoemf();

		Free();
	}else{
		MessageBox(NULL,"Loading xpstotiff.dll failure!", "demo", MB_OK);
	}
}

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------



BOOL TMainForm::Load(){
	char szDLL[] = "xpstopdf.dll";

	hmodule=LoadLibrary(szDLL);
	if(hmodule==NULL)
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(hmodule,"_oakBegin@0");
	if(oakBegin==NULL)
		goto Failer;
	oakEnd=(poakEnd)GetProcAddress(hmodule,"_oakEnd@4");
	if(oakEnd==NULL)
		goto Failer;
	oakExport=(poakExport)GetProcAddress(hmodule,"_oakExport@4");
	if(oakExport==NULL)
		goto Failer;
	oakSetOption=(poakSetOption)GetProcAddress(hmodule,"_oakSetOption@24");
	if(oakSetOption==NULL)
		goto Failer;
	oakGetOption=(poakGetOption)GetProcAddress(hmodule,"_oakGetOption@24");
	if(oakGetOption==NULL)
		goto Failer;
	return TRUE;

Failer:
	Free(); 
	return FALSE;
}


void TMainForm::Free(){
	if(hmodule==NULL)
        return;
	FreeLibrary(hmodule);
	hmodule=NULL;
}

