//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>



//Definitions of oakSetOption's nIndex properties 
//==============================================================================================================
#define OAK_Set_Output		2101
#define OAK_Set_Input		2102
#define OAK_Set_DPI		2103
#define OAK_Set_ColorDepth	2104
#define OAK_Set_PDFInfo		2105
#define OAK_Set_PDFEncrypt	2106
#define OAK_Set_Compression	2108
#define OAK_Set_Quality		2109


//file type's definitions.
//==============================================================================================================
#define OAK_FILE_PDF		100
#define OAK_FILE_TIF		105
#define OAK_FILE_JPG		106
#define OAK_FILE_BMP		107
#define OAK_FILE_GIF		108
#define OAK_FILE_PCX		109
#define OAK_FILE_PNG		110
#define OAK_FILE_EMF		111
#define OAK_FILE_WMF		112

//TIFF tag's definitions.
//==============================================================================================================
#define	OAK_COMPRESSION_NONE		1
#define	OAK_COMPRESSION_RLE		2
#define	OAK_COMPRESSION_G3		3
#define	OAK_COMPRESSION_G4		4
#define	OAK_COMPRESSION_LZW		5
#define	OAK_COMPRESSION_JPEG		6
#define	OAK_COMPRESSION_PACKBITS	7


//Color Depth
//==============================================================================================================
typedef enum {
	oak_color_1	=1,		//2 color
	oak_color_4	=4,		//16 color
	oak_color_8_g	=7,		//256 grayscale
	oak_color_8	=8,		//256 color
	oak_color_24	=24		//true color
} OAK_COLOR_DEPTH;


//Supported pdf information
#define OAK_PDFInfo_TITLE          "title"
#define OAK_PDFInfo_SUBJECT        "subject"
#define OAK_PDFINfo_AUTHOR         "author"
#define OAK_PDFINfo_KEYWORDS       "keywords"
#define OAK_PDFInfo_APPLICATION    "creator"

//Supported the length of pdf encrypt
#define OAK_PDF_ENCRYPT_LEVEL_40   40
#define OAK_PDF_ENCRYPT_LEVEL_128  128

//Supported operation limited
#define OAK_PDF_PERMISSION_NONE     0
#define OAK_PDF_PERMISSION_PRINT    1
#define OAK_PDF_PERMISSION_COPYING  2
#define OAK_PDF_PERMISSION_MODIFY   4
#define OAK_PDF_PERMISSION_ALL      7



//Interface definitions.
//==============================================================================================================
typedef long	(__stdcall *poakBegin)();
typedef void	(__stdcall *poakEnd)(long id);
typedef long	(__stdcall *poakExport)(long id);
typedef long	(__stdcall *poakSetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);
typedef long	(__stdcall *poakGetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);





//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TButton *btnDemo1;
        TProgressBar *m_ProgressBar;
        void __fastcall btnDemo1Click(TObject *Sender);
       
private:	// User declarations
//SDK interface definitions.
//---------------------------------------------------------------------------
	HMODULE hmodule;
	poakBegin oakBegin;
	poakEnd oakEnd;
	poakExport oakExport;
	poakSetOption oakSetOption;
	poakGetOption oakGetOption;

	BOOL Load();
	void Free();
        
	void xpstopdf();
	void xpstotif_MP();
	void xpstotif_OP();
	void xpstojpg();
	void xpstobmp();
	void xpstogif();
	void xpstopng();
	void xpstopcx();
	void xpstoemf();
//	void xpstowmf();
//----------------------------------------------------------------------------

public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
