unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

const
    //Definitions of oakSetOption's nIndex properties
    //======================================================================================================
    OAK_Set_Output = 2101;
    OAK_Set_Input = 2102;
    OAK_Set_DPI = 2103;
    OAK_Set_ColorDepth = 2104;
    OAK_Set_PDFInfo = 2105;
    OAK_Set_PDFEncrypt = 2106;
    OAK_Set_Compression = 2108;
    OAK_Set_Quality = 2109;
   
    //file type's definitions.
    //==============================================================================================================
    OAK_FILE_PDF = 100;
    OAK_FILE_TIF = 105;
    OAK_FILE_JPG = 106;
    OAK_FILE_BMP = 107;
    OAK_FILE_GIF = 108;
    OAK_FILE_PCX = 109;
    OAK_FILE_PNG = 110;
    OAK_FILE_EMF = 111;
    OAK_FILE_WMF = 112;

    //TIFF tag's definitions.
    //==============================================================================================================
    OAK_COMPRESSION_NONE = 1;
    OAK_COMPRESSION_RLE = 2;
    OAK_COMPRESSION_G3 = 3;
    OAK_COMPRESSION_G4 = 4;
    OAK_COMPRESSION_LZW = 5;
    OAK_COMPRESSION_JPEG = 6;
    OAK_COMPRESSION_PACKBITS = 7;


    //Color Depth
    //==============================================================================================================
    oak_color_1 = 1 ;   //2 colors
    oak_color_4 = 4 ;   //16 colors
    oak_color_8_g = 7 ; //256 grayscale colors
    oak_color_8 = 8  ;  //256 colors
    oak_color_24 = 24;  //true colors
   

    //Supported pdf information
    OAK_PDFInfo_TITLE = 'title';
    OAK_PDFInfo_SUBJECT = 'subject';
    OAK_PDFINfo_AUTHOR = 'author';
    OAK_PDFINfo_KEYWORDS = 'keywords';
    OAK_PDFInfo_APPLICATION = 'creator';

    //Supported the length of pdf encrypt
    OAK_PDF_ENCRYPT_LEVEL_40 = 40;
    OAK_PDF_ENCRYPT_LEVEL_128 = 128;

    //Supported operation limited
    OAK_PDF_PERMISSION_NONE = 0;
    OAK_PDF_PERMISSION_PRINT = 1;
    OAK_PDF_PERMISSION_COPYING = 2;
    OAK_PDF_PERMISSION_MODIFY = 4;
    OAK_PDF_PERMISSION_ALL = 7;


type

  //interface definitions.
  //==========================================================================================
    _oakBegin = function():Longint; stdcall;
    _oakEnd = function(nHandle:Longint):Longint; stdcall;
    _oakExport = function(nHandle:Longint):Longint; stdcall;
    _oakSetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;
    _oakGetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;

  //==========================================================================================




  TMainForm = class(TForm)
    btnDemo1: TButton;
    m_ProgressBar: TProgressBar;
    procedure btnDemo1Click(Sender: TObject);
  private
    { Private declarations }


    //---------------------------------------------------------------------------
    m_hDll: HMODULE;
    oakBegin: _oakBegin;
    oakEnd: _oakEnd;
    oakExport: _oakExport;
    oakSetOption: _oakSetOption;
    oakGetOption: _oakGetOption;

    function LoadDLL():BOOL;
    function FreeDLL():BOOL;

    function xpstopdf():Longint;
		function xpstotif_MP():Longint;
		function xpstotif_OP():Longint;
		function xpstojpg():Longint;
		function xpstobmp():Longint;
    function xpstogif():Longint;
		function xpstopng():Longint;
		function xpstopcx():Longint;
		function xpstoemf():Longint;
    //----------------------------------------------------------------------------

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

//==========================================================================================
function TMainForm.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := 'xpstopdf.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, '_oakBegin@0');
	 if pFunc = nil then goto ERR_FLAG;
   oakBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakEnd@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakExport@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakExport := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakSetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakSetOption := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakGetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakGetOption := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;


//==========================================================================================

function TMainForm.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;

function TMainForm.xpstopdf():Longint;
var
    sOutFname: PAnsiChar;
    sUserPw,sOwnerPw: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;
begin

  xdpi:=200;
  ydpi:=200;
  sUserPw:='user';
  sOwnerPw:='owner';

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.pdf';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_PDF, 0, sOutFname, nil);

			//set image DPI ,default xdpi=150,ydpi=150
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

			//set pdf info
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, 'title');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, 'subject');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, 'author');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, 'keywords');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, 'creator');
	
			//set pdf security
			oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, nil, sOwnerPw);
			//oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);

			
			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstotif_MP():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;
    isMultiPage:Longint;
    iCompression:Longint;
begin

    id := oakBegin();
		if id <> 0 then
    begin


			//=============================================================
			//set output file
      isMultiPage:=1;
      sOutFname:= 'MultiPage_g4.tif';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_TIF,isMultiPage,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set COMPRESSION
      iCompression := OAK_COMPRESSION_G4;
      oakSetOption(id, OAK_Set_Compression, iCompression, 0, nil, nil);

      //set Color Depth
      oakSetOption(id, OAK_Set_ColorDepth, oak_color_1, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstotif_OP():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;
    isMultiPage:Longint;
    iCompression:Longint;
begin

    id := oakBegin();
		if id <> 0 then
    begin


			//=============================================================
			//set output file
      isMultiPage:=0;
      sOutFname:= 'lzw.tif';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_TIF,isMultiPage,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set COMPRESSION
      iCompression := OAK_COMPRESSION_LZW;
      oakSetOption(id, OAK_Set_Compression, iCompression, 0, nil, nil);

      //set Color Depth
      //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstojpg():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.jpg';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_JPG,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set jpeg quality (1 - 100)
      oakSetOption(id, OAK_Set_Quality, 75, 0, nil, nil);

      //set Color Depth
      //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstobmp():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.bmp';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_BMP,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set Color Depth
      oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstogif():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.gif';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_GIF,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstopng():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.png';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_PNG,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set Color Depth
      oakSetOption(id, OAK_Set_ColorDepth, oak_color_8_g, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstopcx():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.pcx';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_PCX,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set Color Depth
      //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

function TMainForm.xpstoemf():Longint;
var
    sOutFname: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;

begin

    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
      sOutFname:= 'output.emf';
			oakSetOption(id, OAK_Set_Output,OAK_FILE_EMF,0,sOutFname , nil);

			//set image DPI
      xdpi:=200;ydpi:=200;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //set Color Depth
      //oakSetOption(id, OAK_Set_ColorDepth, oak_color_8, 0, nil, nil);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test1.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test2.xps', nil);
			//oakSetOption(id, OAK_Set_Input, 0, 0, '.\\xps_files\\test3.xps', nil);


			//strat convert
			oakExport(id);

			oakEnd(id);

    end;

end;

//==========================================================================================

procedure TMainForm.btnDemo1Click(Sender: TObject);

begin




	if LoadDLL() = TRUE then
  begin

    xpstopdf();
    xpstotif_MP();
    xpstotif_OP();
    xpstojpg();

    xpstobmp();
    xpstogif();
    xpstopng();
    xpstopcx();
    xpstoemf();

		FreeDLL();

  end
	else
		ShowMessage('Loading dll failure!');



end;



//==========================================================================================


end.
